package info.textgrid.lab.collatex.ui.parts;

import info.textgrid.lab.collatex.model.CollationResults;
import info.textgrid.lab.collatex.ui.parts.CollationSetEditor.ICollationEventHandler;

import org.eclipse.jface.viewers.ContentViewer;
import org.eclipse.ui.part.Page;
import org.eclipse.ui.part.PageBookView;

/**
 * A {@link PageBookView} {@link Page} that displays {@link CollationResults}.
 */
public abstract class AbstractResultPage extends Page implements
ICollationEventHandler {

	private CollationSetEditor collationSetEditor;

	protected CollationSetEditor getCollationSetEditor() {
		return collationSetEditor;
	}

	public AbstractResultPage() {
		super();
	}

	public void setEditor(final CollationSetEditor part) {
		this.collationSetEditor = part;
		collationSetEditor.addCollationListener(this);
		if (collationSetEditor.getCollationResults() != null)
			newCollationResults(collationSetEditor.getCollationResults());
	}

	@Override
	public void dispose() {
		if (collationSetEditor != null)
			collationSetEditor.removeCollationListener(this);
		super.dispose();
	}


	@Override
	public void newCollationResults(final CollationResults results) {
		if (getViewer() != null)
			getViewer().setInput(results);
	}

	protected abstract ContentViewer getViewer();


}